#!/usr/bin/python3

import string
import sys

alphabet = (
    string.digits
    + string.ascii_uppercase
    + string.ascii_lowercase
    + string.punctuation
    + " "
)


def convert_base(num, to_base=10, from_base=10):
    if to_base == 1:
        return "1" * num

    # first convert to decimal number
    n = int(num, from_base) if isinstance(num, str) else num
    # now convert decimal to 'to_base' base
    res = ""
    while n > 0:
        n, m = divmod(n, to_base)
        res += alphabet[m]
    return res[::-1]


# example usage
if __name__ == "__main__":
    a = input("Decimal integer: ")
    b = input("New integer base: ")
    a = int(a)
    b = int(b)
    result = convert_base(a, b, 10)
    print("%d{10} -> %s{%d}" % (a, result, b))
