#!/usr/bin/python3

import random

QUESTION = "Did you cheat"
HEAD = 0
TAILS = 1
QUESTION_COUNT = 50
flip_coin = lambda: random.randint(0, 1) == 1
fast_lower_char = lambda c: chr(ord(c) | 0x20)
ask_user = lambda: fast_lower_char(neutral_input("%s? (y/n): " % QUESTION).strip()[0]) == "y"


def neutral_input(prompt):
    try:
        return input(prompt)
    except KeyboardInterrupt or EOFError:
        raise SystemExit


def get_response():
    res = [0] * 2

    print("Flipping coin")
    if flip_coin() == HEAD:
        print("Head")
        res[0] = ask_user()
    else:
        print("Tails : Flipping again")
        res[0] = flip_coin() == 1
        if res[0] is True:
            print("Head : Telling 'yes'")
        else:
            print("Tails : Telling 'no'")
        res[1] = ask_user()
    return res


num_yes = 0
for i in range(QUESTION_COUNT):
    print(f"Question #{i+1}:")
    response = get_response()
    if response[0]:
        num_yes += 1
        print("You responded 'yes'")
    else:
        print("You responded 'no'")

print(f"Estimated proportion who said 'yes': {num_yes / QUESTION_COUNT}")
